javax.resource.spi.endpoint

## Interface MessageEndpoint

-     public interface MessageEndpoint

  This defines a contract for a message endpoint. This is implemented by an application server.
  Version:
    1.0
  Author:
    Ram Jeyaraman

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterDelivery()` This is called by a resource adapter after a message is delivered.
    `void` | `beforeDelivery(Method method)` This is called by a resource adapter before a message is delivered.
    `void` | `release()` This method may be called by the resource adapter to indicate that it no longer needs a proxy endpoint instance.

- - ### Method Detail

    - #### beforeDelivery

          void beforeDelivery(Method method)
                              throws NoSuchMethodException,
                                     ResourceException

      This is called by a resource adapter before a message is delivered.
      Parameters:
        `method` - description of a target method. This information about the intended target method allows an application server to decide whether to start a transaction during this method call, depending on the transaction preferences of the target method. The processing (by the application server) of the actual message delivery method call on the endpoint must be independent of the class loader associated with this descriptive method object.
      Throws:
        `NoSuchMethodException` - indicates that the specified method does not exist on the target endpoint.
        `ResourceException` - generic exception.
        `ApplicationServerInternalException` - indicates an error condition in the application server.
        `IllegalStateException` - indicates that the endpoint is in an illegal state for the method invocation. For example, this occurs when `beforeDelivery` and `afterDelivery` method calls are not paired.
        `UnavailableException` - indicates that the endpoint is not available.

    - #### afterDelivery

          void afterDelivery()
                             throws ResourceException

      This is called by a resource adapter after a message is delivered.
      Throws:
        `ResourceException` - generic exception.
        `ApplicationServerInternalException` - indicates an error condition in the application server.
        `IllegalStateException` - indicates that the endpoint is in an illegal state for the method invocation. For example, this occurs when beforeDelivery and afterDelivery method calls are not paired.
        `UnavailableException` - indicates that the endpoint is not available.

    - #### release

          void release()

      This method may be called by the resource adapter to indicate that it no longer needs a proxy endpoint instance. This hint may be used by the application server for endpoint pooling decisions.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.